typedef struct
{
	UCHAR frame;
	UCHAR second;
	UCHAR minute;
	UCHAR empty;
} MSF;

typedef struct
{
   UCHAR signature[4];
   UCHAR addressingMode; /* 0 = HSG, 1 = MSF */
   MSF start; /* can be HSG */
   MSF end;
} CDPLAYAUDIOPARAM;

typedef struct
{
	UCHAR firstTrack;
	UCHAR lastTrack;
	MSF leadOutAddress;
} CDAUDIODISKINFODATA;

typedef struct
{
	UCHAR signature[4];
	UCHAR trackNum;
} CDAUDIOTRACKINFOPARAM;

typedef struct
{
	MSF address;
	UCHAR info;
	#if 0
		bit 7  4 or 2 channels
		bit 6  data or audio track
		bit 5  copy ok or not ok
		bit 4  with or without preemp
		bit 3-0 ADR stuff?? whatever that is
	#endif
} CDAUDIOTRACKINFODATA;

typedef struct
{
   MSF length;
   ULONG size;
   BOOL data;
   ULONG channels;
   MSF start;
   MSF end;
} CDTRACKINFO;


HFILE openCD(char *drive);
ULONG closeCD(HFILE hCDDrive);
BOOL getCDInfo(HFILE hCDDrive, CDAUDIODISKINFODATA *cdInfo);
BOOL getTrackInfo(HFILE hCDDrive, char track, CDTRACKINFO *trackInfo2);
BOOL playTrack(HFILE hCDDrive, char track);
BOOL stopCD(HFILE hCDDrive);
