/* CD2MP3 PM 1.0 (C) 1998 Samuel Audet <guardia@cam.org> */

#define INCL_PM
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#include "pmsam.h"
#include "spawner.h"
#include "wav.h"
#include "cd2mp3pm.h"
#include "wav2mp3.h"

HAPP wav2mp3(WAV2MP3_IN *input, WAV2MP3_END *output)
{
	char mp3file[512];
	char *wavname,*dot;
	char cmdline[1024] = {0};
	SPAWNER_PARAM spawnerParam;

	strcpy(mp3file, input->mp3dir);
	wavname = strrchr(input->wavfile, '\\');
	if(wavname == NULL)
		wavname = input->wavfile;
	else
		wavname++;
	strcat(mp3file,wavname);
	dot = strrchr(mp3file,'.');
	if(dot != NULL) *dot = 0;
	strcat(mp3file,".mp3");

	/* building the command line */

	strcpy(cmdline, input->encoder->before);
	strcat(cmdline, " ");

	sprintf(cmdline,"%s\"%s\" ", input->encoder->input, input->wavfile);

	if(input->encoder->acceptsOutput)
		sprintf(strchr(cmdline,0),"%s\"%s\" ", input->encoder->output, mp3file);

	if(input->bitrate)
	{
		if(input->encoder->bitratePerChannel)
		{
			RIFF RIFFheader;
			int hfile;
			int samplerate, channels, bits, format, size;

			hfile = openWAV(input->wavfile, READ, &RIFFheader,
								 &samplerate, &channels, &bits, &format, &size);
			if(hfile)
			{
				if(channels)
					input->bitrate /= channels;
				closeWAV(hfile);
			}
		}

		sprintf(strchr(cmdline,'\0'), "%s%d ",input->encoder->bitrate,
			input->bitrate*input->encoder->bitrateMath);
	}

	if(input->hq)
		strcat(cmdline,input->encoder->hq);
	else
		strcat(cmdline,input->encoder->lq);
	strcat(cmdline," ");

	strcat(cmdline,input->encoder->after);
	strcat(cmdline," ");
	strcat(cmdline,input->custom);

	spawnerParam.program = input->encoder->exe;
	spawnerParam.cmdline = cmdline;
	if(input->lowprio)
	{
		spawnerParam.prioClass = PRTYC_IDLETIME;
		spawnerParam.prioDelta = 1; /* wee bit higher than grabber */
	}
	else
	{
		spawnerParam.prioClass = PRTYC_REGULAR;
		spawnerParam.prioDelta = 1;
	}
	spawnerParam.hwnd = input->hwnd;

	switch(input->encoder->type)
	{
		case WIN32OS2:
			return doWin32OS2(&spawnerParam);
		case VDM:
			spawnerParam.sessionType = PROG_WINDOWEDVDM;
			return doNormal(&spawnerParam);
		case VIO:
			spawnerParam.sessionType = PROG_WINDOWABLEVIO;
			return doNormal(&spawnerParam);
		default:
			return NULLHANDLE;
	}
}

BOOL wav2mp3_end(WAV2MP3_END *input)
{
//   return !rename(input->oldname,input->newname);
	return TRUE;
}
